<Cabbage>
form caption("Quartet 1") size(450, 300), guiMode("queue"), pluginId("qurt")
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0
</CsOptions>
<CsInstruments>
; Initialize the global variables.
ksmps = 32
nchnls = 2
0dbfs = 1

#include "../src/creator.csd"
#include "../src/bbox.csd"

giMaxParts init 4
giMaxOps init 4

; this offset is added to the data when an algorithm is selected
giAlgorithmOffset = 20
gkPartMidiChannel[] init giMaxParts
gkPartAlgorithm[] init giMaxParts

gSPart0Keys[] init 1
gSPart1Keys[] init 1
gSPart2Keys[] init 1
gSPart3Keys[] init 1

; Cabbage hack
opcode cabbageGetValue, i[], S[]
    SChannels[] xin
    iLen = lenarray(SChannels)
    iVal[] init iLen
    iCount = 0
    while iCount < iLen do
        prints("[%d] '%s'\n", iCount, SChannels[iCount])
        iVal[iCount] cabbageGetValue SChannels[iCount]
        iCount += 1
    od
    xout iVal
endop

opcode getPartKeys, S[], i
    iNdx xin
    SPartKeys[] fillarray "unknown"
    if iNdx == 0 then
        SPartKeys = gSPart0Keys
    elseif iNdx == 1 then
        SPartKeys = gSPart1Keys
    elseif iNdx == 2 then
        SPartKeys = gSPart2Keys
    elseif iNdx == 3 then
        SPartKeys = gSPart3Keys
    endif
;    prints "iNdx %d getPartKeys\n", iNdx
;    printarray SPartKeys
    xout SPartKeys
endop

#include "tuning.csd"
#include "midihandler.csd"
#include "seqhandler.csd"
#include "linehandler.csd"

;#include "operators.csd"

#include "guihelpers.csd"
#include "builder.csd"

instr testing
    SPartKeys[] = getPartKeys(p4)
    iPartData[] = cabbageGetValue(SPartKeys)
    iLen = lenarray(SPartKeys)
    iCount = 0
    while iCount < iLen do
        prints("[%d] '%s' %f\n", iCount, SPartKeys[iCount], iPartData[iCount])
;        prints("[%d] '%s'\n", iCount, SPartKeys[iCount])
        iCount += 1
    od
endin

/*
instr testing
    iPartData[] cabbageGetValue gSPart0Keys
    iLen = lenarray(iPartData)
    iCount = 0
    while iCount < iLen do
        prints "[%d] %f\n", iCount, iPartData[iCount]
        iCount += 1
    od

    kValues[] cabbageGetValue gSPart0Keys
    kLen = lenarray:k(kValues)
    kCount = 0
    while kCount < kLen do
        printsk "[%d] '%s' %f\n", kCount, gSPart0Keys[kCount], kValues[kCount]

        kCount += 1
    od
    printsk("Cent: %f\n", cent(-9600) * 55)
    printsk("Cent: %f\n", cent(9600) * 55)

    turnoff
endin
*/

</CsInstruments>
<CsScore>
i "builder" 0 0
i "gui4helper" 0.001 -1
i "freq4helper" 0.001 -1

i "testing" 0.001 0.001 3

;causes Csound to run for about 7000 years...
f0 z
</CsScore>
</CsoundSynthesizer>
